 require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/labels/qqoqcp_configs', type: :request do
  # Labels::QqoqcpConfig. As you add validations to Labels::QqoqcpConfig, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { { name: 'QQOQCP' } }
  let(:invalid_attributes) { { name: nil } }

  let(:user) { FactoryBot.create(:user) }

  before :each do
    sign_in user
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      Labels::QqoqcpConfig.create! valid_attributes
      get labels_qqoqcp_configs_url
      expect(response).to be_successful
    end
  end

  # describe 'GET /show' do
  #   it 'renders a successful response' do
  #     labels_qqoqcp_config = Labels::QqoqcpConfig.create! valid_attributes
  #     get labels_qqoqcp_config_url(labels_qqoqcp_config)
  #     expect(response).to be_successful
  #   end
  # end

  describe 'GET /new' do
    it 'renders a successful response' do
      get new_labels_qqoqcp_config_url
      expect(response).to be_successful
    end
  end

  describe 'GET /edit' do
    it 'render a successful response' do
      labels_qqoqcp_config = Labels::QqoqcpConfig.create! valid_attributes
      get edit_labels_qqoqcp_config_url(labels_qqoqcp_config)
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Labels::QqoqcpConfig' do
        expect {
          post labels_qqoqcp_configs_url, params: { labels_qqoqcp_config: valid_attributes }
        }.to change(Labels::QqoqcpConfig, :count).by(1)
      end

      it 'redirects to labels_qqoqcp_configs list' do
        post labels_qqoqcp_configs_url, params: { labels_qqoqcp_config: valid_attributes }
        expect(response).to redirect_to(labels_qqoqcp_configs_url)
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Labels::QqoqcpConfig' do
        expect {
          post labels_qqoqcp_configs_url, params: { labels_qqoqcp_config: invalid_attributes }
        }.to change(Labels::QqoqcpConfig, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post labels_qqoqcp_configs_url, params: { labels_qqoqcp_config: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) { { name: 'NEW NAME' } }

      it 'updates the requested labels_qqoqcp_config' do
        labels_qqoqcp_config = Labels::QqoqcpConfig.create! valid_attributes
        patch labels_qqoqcp_config_url(labels_qqoqcp_config), params: { labels_qqoqcp_config: new_attributes }
        labels_qqoqcp_config.reload
        expect(labels_qqoqcp_config.name).to eq 'NEW NAME'
      end

      it 'redirects to labels_qqoqcp_configs list' do
        labels_qqoqcp_config = Labels::QqoqcpConfig.create! valid_attributes
        patch labels_qqoqcp_config_url(labels_qqoqcp_config), params: { labels_qqoqcp_config: new_attributes }
        labels_qqoqcp_config.reload
        expect(response).to redirect_to(labels_qqoqcp_configs_url)
      end
    end

    context 'with invalid parameters' do
      it 'renders a successful response (i.e. to display the edit template)' do
        labels_qqoqcp_config = Labels::QqoqcpConfig.create! valid_attributes
        patch labels_qqoqcp_config_url(labels_qqoqcp_config), params: { labels_qqoqcp_config: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested labels_qqoqcp_config' do
      labels_qqoqcp_config = Labels::QqoqcpConfig.create! valid_attributes
      expect {
        delete labels_qqoqcp_config_url(labels_qqoqcp_config)
      }.to change(Labels::QqoqcpConfig, :count).by(-1)
    end

    it 'redirects to the labels_qqoqcp_configs list' do
      labels_qqoqcp_config = Labels::QqoqcpConfig.create! valid_attributes
      delete labels_qqoqcp_config_url(labels_qqoqcp_config)
      expect(response).to redirect_to(labels_qqoqcp_configs_url)
    end
  end
end
